# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ConversionSourceMetrics(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'float',
        'conversion_source': 'str',
        'orders_count': 'float',
        'revenue': 'float',
        'average_basket': 'float'
    }

    attribute_map = {
        'id': 'id',
        'conversion_source': 'conversionSource',
        'orders_count': 'ordersCount',
        'revenue': 'revenue',
        'average_basket': 'averageBasket'
    }

    def __init__(self, id=None, conversion_source=None, orders_count=None, revenue=None, average_basket=None):  # noqa: E501
        """ConversionSourceMetrics - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._conversion_source = None
        self._orders_count = None
        self._revenue = None
        self._average_basket = None
        self.discriminator = None

        self.id = id
        self.conversion_source = conversion_source
        self.orders_count = orders_count
        self.revenue = revenue
        self.average_basket = average_basket

    @property
    def id(self):
        """Gets the id of this ConversionSourceMetrics.  # noqa: E501


        :return: The id of this ConversionSourceMetrics.  # noqa: E501
        :rtype: float
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ConversionSourceMetrics.


        :param id: The id of this ConversionSourceMetrics.  # noqa: E501
        :type: float
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def conversion_source(self):
        """Gets the conversion_source of this ConversionSourceMetrics.  # noqa: E501


        :return: The conversion_source of this ConversionSourceMetrics.  # noqa: E501
        :rtype: str
        """
        return self._conversion_source

    @conversion_source.setter
    def conversion_source(self, conversion_source):
        """Sets the conversion_source of this ConversionSourceMetrics.


        :param conversion_source: The conversion_source of this ConversionSourceMetrics.  # noqa: E501
        :type: str
        """
        if conversion_source is None:
            raise ValueError("Invalid value for `conversion_source`, must not be `None`")  # noqa: E501
        allowed_values = ["email_campaign"]  # noqa: E501
        if conversion_source not in allowed_values:
            raise ValueError(
                "Invalid value for `conversion_source` ({0}), must be one of {1}"  # noqa: E501
                .format(conversion_source, allowed_values)
            )

        self._conversion_source = conversion_source

    @property
    def orders_count(self):
        """Gets the orders_count of this ConversionSourceMetrics.  # noqa: E501


        :return: The orders_count of this ConversionSourceMetrics.  # noqa: E501
        :rtype: float
        """
        return self._orders_count

    @orders_count.setter
    def orders_count(self, orders_count):
        """Sets the orders_count of this ConversionSourceMetrics.


        :param orders_count: The orders_count of this ConversionSourceMetrics.  # noqa: E501
        :type: float
        """
        if orders_count is None:
            raise ValueError("Invalid value for `orders_count`, must not be `None`")  # noqa: E501

        self._orders_count = orders_count

    @property
    def revenue(self):
        """Gets the revenue of this ConversionSourceMetrics.  # noqa: E501


        :return: The revenue of this ConversionSourceMetrics.  # noqa: E501
        :rtype: float
        """
        return self._revenue

    @revenue.setter
    def revenue(self, revenue):
        """Sets the revenue of this ConversionSourceMetrics.


        :param revenue: The revenue of this ConversionSourceMetrics.  # noqa: E501
        :type: float
        """
        if revenue is None:
            raise ValueError("Invalid value for `revenue`, must not be `None`")  # noqa: E501

        self._revenue = revenue

    @property
    def average_basket(self):
        """Gets the average_basket of this ConversionSourceMetrics.  # noqa: E501


        :return: The average_basket of this ConversionSourceMetrics.  # noqa: E501
        :rtype: float
        """
        return self._average_basket

    @average_basket.setter
    def average_basket(self, average_basket):
        """Sets the average_basket of this ConversionSourceMetrics.


        :param average_basket: The average_basket of this ConversionSourceMetrics.  # noqa: E501
        :type: float
        """
        if average_basket is None:
            raise ValueError("Invalid value for `average_basket`, must not be `None`")  # noqa: E501

        self._average_basket = average_basket

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ConversionSourceMetrics, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConversionSourceMetrics):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
