# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class CreateDomainModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'domain_name': 'str',
        'domain_provider': 'str',
        'message': 'str',
        'dns_records': 'CreateDomainModelDnsRecords'
    }

    attribute_map = {
        'id': 'id',
        'domain_name': 'domain_name',
        'domain_provider': 'domain_provider',
        'message': 'message',
        'dns_records': 'dns_records'
    }

    def __init__(self, id=None, domain_name=None, domain_provider=None, message=None, dns_records=None):  # noqa: E501
        """CreateDomainModel - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._domain_name = None
        self._domain_provider = None
        self._message = None
        self._dns_records = None
        self.discriminator = None

        self.id = id
        if domain_name is not None:
            self.domain_name = domain_name
        if domain_provider is not None:
            self.domain_provider = domain_provider
        if message is not None:
            self.message = message
        if dns_records is not None:
            self.dns_records = dns_records

    @property
    def id(self):
        """Gets the id of this CreateDomainModel.  # noqa: E501

        ID of the Domain created  # noqa: E501

        :return: The id of this CreateDomainModel.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CreateDomainModel.

        ID of the Domain created  # noqa: E501

        :param id: The id of this CreateDomainModel.  # noqa: E501
        :type: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def domain_name(self):
        """Gets the domain_name of this CreateDomainModel.  # noqa: E501

        Domain  # noqa: E501

        :return: The domain_name of this CreateDomainModel.  # noqa: E501
        :rtype: str
        """
        return self._domain_name

    @domain_name.setter
    def domain_name(self, domain_name):
        """Sets the domain_name of this CreateDomainModel.

        Domain  # noqa: E501

        :param domain_name: The domain_name of this CreateDomainModel.  # noqa: E501
        :type: str
        """

        self._domain_name = domain_name

    @property
    def domain_provider(self):
        """Gets the domain_provider of this CreateDomainModel.  # noqa: E501

        Domain Provider  # noqa: E501

        :return: The domain_provider of this CreateDomainModel.  # noqa: E501
        :rtype: str
        """
        return self._domain_provider

    @domain_provider.setter
    def domain_provider(self, domain_provider):
        """Sets the domain_provider of this CreateDomainModel.

        Domain Provider  # noqa: E501

        :param domain_provider: The domain_provider of this CreateDomainModel.  # noqa: E501
        :type: str
        """

        self._domain_provider = domain_provider

    @property
    def message(self):
        """Gets the message of this CreateDomainModel.  # noqa: E501

        Success message  # noqa: E501

        :return: The message of this CreateDomainModel.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this CreateDomainModel.

        Success message  # noqa: E501

        :param message: The message of this CreateDomainModel.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def dns_records(self):
        """Gets the dns_records of this CreateDomainModel.  # noqa: E501


        :return: The dns_records of this CreateDomainModel.  # noqa: E501
        :rtype: CreateDomainModelDnsRecords
        """
        return self._dns_records

    @dns_records.setter
    def dns_records(self, dns_records):
        """Sets the dns_records of this CreateDomainModel.


        :param dns_records: The dns_records of this CreateDomainModel.  # noqa: E501
        :type: CreateDomainModelDnsRecords
        """

        self._dns_records = dns_records

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateDomainModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateDomainModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
