# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class CreateSenderModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'spf_error': 'bool',
        'dkim_error': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'spf_error': 'spfError',
        'dkim_error': 'dkimError'
    }

    def __init__(self, id=None, spf_error=None, dkim_error=None):  # noqa: E501
        """CreateSenderModel - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._spf_error = None
        self._dkim_error = None
        self.discriminator = None

        self.id = id
        if spf_error is not None:
            self.spf_error = spf_error
        if dkim_error is not None:
            self.dkim_error = dkim_error

    @property
    def id(self):
        """Gets the id of this CreateSenderModel.  # noqa: E501

        ID of the Sender created  # noqa: E501

        :return: The id of this CreateSenderModel.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CreateSenderModel.

        ID of the Sender created  # noqa: E501

        :param id: The id of this CreateSenderModel.  # noqa: E501
        :type: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def spf_error(self):
        """Gets the spf_error of this CreateSenderModel.  # noqa: E501

        Status of SPF configuration for the sender (true = SPF not well configured, false = SPF well configured)  # noqa: E501

        :return: The spf_error of this CreateSenderModel.  # noqa: E501
        :rtype: bool
        """
        return self._spf_error

    @spf_error.setter
    def spf_error(self, spf_error):
        """Sets the spf_error of this CreateSenderModel.

        Status of SPF configuration for the sender (true = SPF not well configured, false = SPF well configured)  # noqa: E501

        :param spf_error: The spf_error of this CreateSenderModel.  # noqa: E501
        :type: bool
        """

        self._spf_error = spf_error

    @property
    def dkim_error(self):
        """Gets the dkim_error of this CreateSenderModel.  # noqa: E501

        Status of DKIM configuration for the sender (true = DKIM not well configured, false = DKIM well configured)  # noqa: E501

        :return: The dkim_error of this CreateSenderModel.  # noqa: E501
        :rtype: bool
        """
        return self._dkim_error

    @dkim_error.setter
    def dkim_error(self, dkim_error):
        """Sets the dkim_error of this CreateSenderModel.

        Status of DKIM configuration for the sender (true = DKIM not well configured, false = DKIM well configured)  # noqa: E501

        :param dkim_error: The dkim_error of this CreateSenderModel.  # noqa: E501
        :type: bool
        """

        self._dkim_error = dkim_error

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateSenderModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateSenderModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
