# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class CreateUpdateBatchProducts(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'products': 'list[CreateUpdateProducts]',
        'update_enabled': 'bool'
    }

    attribute_map = {
        'products': 'products',
        'update_enabled': 'updateEnabled'
    }

    def __init__(self, products=None, update_enabled=None):  # noqa: E501
        """CreateUpdateBatchProducts - a model defined in Swagger"""  # noqa: E501

        self._products = None
        self._update_enabled = None
        self.discriminator = None

        self.products = products
        if update_enabled is not None:
            self.update_enabled = update_enabled

    @property
    def products(self):
        """Gets the products of this CreateUpdateBatchProducts.  # noqa: E501

        array of products objects  # noqa: E501

        :return: The products of this CreateUpdateBatchProducts.  # noqa: E501
        :rtype: list[CreateUpdateProducts]
        """
        return self._products

    @products.setter
    def products(self, products):
        """Sets the products of this CreateUpdateBatchProducts.

        array of products objects  # noqa: E501

        :param products: The products of this CreateUpdateBatchProducts.  # noqa: E501
        :type: list[CreateUpdateProducts]
        """
        if products is None:
            raise ValueError("Invalid value for `products`, must not be `None`")  # noqa: E501

        self._products = products

    @property
    def update_enabled(self):
        """Gets the update_enabled of this CreateUpdateBatchProducts.  # noqa: E501

        Facilitate to update the existing categories in the same request (updateEnabled = true)  # noqa: E501

        :return: The update_enabled of this CreateUpdateBatchProducts.  # noqa: E501
        :rtype: bool
        """
        return self._update_enabled

    @update_enabled.setter
    def update_enabled(self, update_enabled):
        """Sets the update_enabled of this CreateUpdateBatchProducts.

        Facilitate to update the existing categories in the same request (updateEnabled = true)  # noqa: E501

        :param update_enabled: The update_enabled of this CreateUpdateBatchProducts.  # noqa: E501
        :type: bool
        """

        self._update_enabled = update_enabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateUpdateBatchProducts, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateUpdateBatchProducts):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
