# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class CreateUpdateCategory(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'url': 'str',
        'update_enabled': 'bool',
        'deleted_at': 'str',
        'is_deleted': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'url': 'url',
        'update_enabled': 'updateEnabled',
        'deleted_at': 'deletedAt',
        'is_deleted': 'isDeleted'
    }

    def __init__(self, id=None, name=None, url=None, update_enabled=False, deleted_at=None, is_deleted=None):  # noqa: E501
        """CreateUpdateCategory - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._name = None
        self._url = None
        self._update_enabled = None
        self._deleted_at = None
        self._is_deleted = None
        self.discriminator = None

        self.id = id
        if name is not None:
            self.name = name
        if url is not None:
            self.url = url
        if update_enabled is not None:
            self.update_enabled = update_enabled
        if deleted_at is not None:
            self.deleted_at = deleted_at
        if is_deleted is not None:
            self.is_deleted = is_deleted

    @property
    def id(self):
        """Gets the id of this CreateUpdateCategory.  # noqa: E501

        Unique Category ID as saved in the shop   # noqa: E501

        :return: The id of this CreateUpdateCategory.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CreateUpdateCategory.

        Unique Category ID as saved in the shop   # noqa: E501

        :param id: The id of this CreateUpdateCategory.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this CreateUpdateCategory.  # noqa: E501

        **Mandatory in case of creation**. Name of the Category, as displayed in the shop   # noqa: E501

        :return: The name of this CreateUpdateCategory.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateUpdateCategory.

        **Mandatory in case of creation**. Name of the Category, as displayed in the shop   # noqa: E501

        :param name: The name of this CreateUpdateCategory.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def url(self):
        """Gets the url of this CreateUpdateCategory.  # noqa: E501

        URL to the category  # noqa: E501

        :return: The url of this CreateUpdateCategory.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this CreateUpdateCategory.

        URL to the category  # noqa: E501

        :param url: The url of this CreateUpdateCategory.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def update_enabled(self):
        """Gets the update_enabled of this CreateUpdateCategory.  # noqa: E501

        Facilitate to update the existing category in the same request (updateEnabled = true)  # noqa: E501

        :return: The update_enabled of this CreateUpdateCategory.  # noqa: E501
        :rtype: bool
        """
        return self._update_enabled

    @update_enabled.setter
    def update_enabled(self, update_enabled):
        """Sets the update_enabled of this CreateUpdateCategory.

        Facilitate to update the existing category in the same request (updateEnabled = true)  # noqa: E501

        :param update_enabled: The update_enabled of this CreateUpdateCategory.  # noqa: E501
        :type: bool
        """

        self._update_enabled = update_enabled

    @property
    def deleted_at(self):
        """Gets the deleted_at of this CreateUpdateCategory.  # noqa: E501

        UTC date-time (YYYY-MM-DDTHH:mm:ss.SSSZ) of the category deleted from the shop's database  # noqa: E501

        :return: The deleted_at of this CreateUpdateCategory.  # noqa: E501
        :rtype: str
        """
        return self._deleted_at

    @deleted_at.setter
    def deleted_at(self, deleted_at):
        """Sets the deleted_at of this CreateUpdateCategory.

        UTC date-time (YYYY-MM-DDTHH:mm:ss.SSSZ) of the category deleted from the shop's database  # noqa: E501

        :param deleted_at: The deleted_at of this CreateUpdateCategory.  # noqa: E501
        :type: str
        """

        self._deleted_at = deleted_at

    @property
    def is_deleted(self):
        """Gets the is_deleted of this CreateUpdateCategory.  # noqa: E501

        category deleted from the shop's database  # noqa: E501

        :return: The is_deleted of this CreateUpdateCategory.  # noqa: E501
        :rtype: bool
        """
        return self._is_deleted

    @is_deleted.setter
    def is_deleted(self, is_deleted):
        """Sets the is_deleted of this CreateUpdateCategory.

        category deleted from the shop's database  # noqa: E501

        :param is_deleted: The is_deleted of this CreateUpdateCategory.  # noqa: E501
        :type: bool
        """

        self._is_deleted = is_deleted

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateUpdateCategory, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateUpdateCategory):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
