# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class CreateWhatsAppCampaign(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'template_id': 'int',
        'scheduled_at': 'str',
        'recipients': 'CreateWhatsAppCampaignRecipients'
    }

    attribute_map = {
        'name': 'name',
        'template_id': 'templateId',
        'scheduled_at': 'scheduledAt',
        'recipients': 'recipients'
    }

    def __init__(self, name=None, template_id=None, scheduled_at=None, recipients=None):  # noqa: E501
        """CreateWhatsAppCampaign - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._template_id = None
        self._scheduled_at = None
        self._recipients = None
        self.discriminator = None

        self.name = name
        self.template_id = template_id
        self.scheduled_at = scheduled_at
        self.recipients = recipients

    @property
    def name(self):
        """Gets the name of this CreateWhatsAppCampaign.  # noqa: E501

        Name of the WhatsApp campaign creation  # noqa: E501

        :return: The name of this CreateWhatsAppCampaign.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateWhatsAppCampaign.

        Name of the WhatsApp campaign creation  # noqa: E501

        :param name: The name of this CreateWhatsAppCampaign.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def template_id(self):
        """Gets the template_id of this CreateWhatsAppCampaign.  # noqa: E501

        Id of the WhatsApp template in **approved** state  # noqa: E501

        :return: The template_id of this CreateWhatsAppCampaign.  # noqa: E501
        :rtype: int
        """
        return self._template_id

    @template_id.setter
    def template_id(self, template_id):
        """Sets the template_id of this CreateWhatsAppCampaign.

        Id of the WhatsApp template in **approved** state  # noqa: E501

        :param template_id: The template_id of this CreateWhatsAppCampaign.  # noqa: E501
        :type: int
        """
        if template_id is None:
            raise ValueError("Invalid value for `template_id`, must not be `None`")  # noqa: E501

        self._template_id = template_id

    @property
    def scheduled_at(self):
        """Gets the scheduled_at of this CreateWhatsAppCampaign.  # noqa: E501

        Sending UTC date-time (YYYY-MM-DDTHH:mm:ss.SSSZ). **Prefer to pass your timezone in date-time format for accurate result.For example: **2017-06-01T12:30:00+02:00**   # noqa: E501

        :return: The scheduled_at of this CreateWhatsAppCampaign.  # noqa: E501
        :rtype: str
        """
        return self._scheduled_at

    @scheduled_at.setter
    def scheduled_at(self, scheduled_at):
        """Sets the scheduled_at of this CreateWhatsAppCampaign.

        Sending UTC date-time (YYYY-MM-DDTHH:mm:ss.SSSZ). **Prefer to pass your timezone in date-time format for accurate result.For example: **2017-06-01T12:30:00+02:00**   # noqa: E501

        :param scheduled_at: The scheduled_at of this CreateWhatsAppCampaign.  # noqa: E501
        :type: str
        """
        if scheduled_at is None:
            raise ValueError("Invalid value for `scheduled_at`, must not be `None`")  # noqa: E501

        self._scheduled_at = scheduled_at

    @property
    def recipients(self):
        """Gets the recipients of this CreateWhatsAppCampaign.  # noqa: E501


        :return: The recipients of this CreateWhatsAppCampaign.  # noqa: E501
        :rtype: CreateWhatsAppCampaignRecipients
        """
        return self._recipients

    @recipients.setter
    def recipients(self, recipients):
        """Sets the recipients of this CreateWhatsAppCampaign.


        :param recipients: The recipients of this CreateWhatsAppCampaign.  # noqa: E501
        :type: CreateWhatsAppCampaignRecipients
        """
        if recipients is None:
            raise ValueError("Invalid value for `recipients`, must not be `None`")  # noqa: E501

        self._recipients = recipients

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateWhatsAppCampaign, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateWhatsAppCampaign):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
