# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class EventIdentifiers(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'email_id': 'str',
        'phone_id': 'str',
        'whatsapp_id': 'str',
        'landline_number_id': 'str',
        'ext_id': 'str'
    }

    attribute_map = {
        'email_id': 'email_id',
        'phone_id': 'phone_id',
        'whatsapp_id': 'whatsapp_id',
        'landline_number_id': 'landline_number_id',
        'ext_id': 'ext_id'
    }

    def __init__(self, email_id=None, phone_id=None, whatsapp_id=None, landline_number_id=None, ext_id=None):  # noqa: E501
        """EventIdentifiers - a model defined in Swagger"""  # noqa: E501

        self._email_id = None
        self._phone_id = None
        self._whatsapp_id = None
        self._landline_number_id = None
        self._ext_id = None
        self.discriminator = None

        if email_id is not None:
            self.email_id = email_id
        if phone_id is not None:
            self.phone_id = phone_id
        if whatsapp_id is not None:
            self.whatsapp_id = whatsapp_id
        if landline_number_id is not None:
            self.landline_number_id = landline_number_id
        if ext_id is not None:
            self.ext_id = ext_id

    @property
    def email_id(self):
        """Gets the email_id of this EventIdentifiers.  # noqa: E501

        Email Id associated with the event  # noqa: E501

        :return: The email_id of this EventIdentifiers.  # noqa: E501
        :rtype: str
        """
        return self._email_id

    @email_id.setter
    def email_id(self, email_id):
        """Sets the email_id of this EventIdentifiers.

        Email Id associated with the event  # noqa: E501

        :param email_id: The email_id of this EventIdentifiers.  # noqa: E501
        :type: str
        """

        self._email_id = email_id

    @property
    def phone_id(self):
        """Gets the phone_id of this EventIdentifiers.  # noqa: E501

        SMS associated with the event  # noqa: E501

        :return: The phone_id of this EventIdentifiers.  # noqa: E501
        :rtype: str
        """
        return self._phone_id

    @phone_id.setter
    def phone_id(self, phone_id):
        """Sets the phone_id of this EventIdentifiers.

        SMS associated with the event  # noqa: E501

        :param phone_id: The phone_id of this EventIdentifiers.  # noqa: E501
        :type: str
        """

        self._phone_id = phone_id

    @property
    def whatsapp_id(self):
        """Gets the whatsapp_id of this EventIdentifiers.  # noqa: E501

        whatsapp associated with the event  # noqa: E501

        :return: The whatsapp_id of this EventIdentifiers.  # noqa: E501
        :rtype: str
        """
        return self._whatsapp_id

    @whatsapp_id.setter
    def whatsapp_id(self, whatsapp_id):
        """Sets the whatsapp_id of this EventIdentifiers.

        whatsapp associated with the event  # noqa: E501

        :param whatsapp_id: The whatsapp_id of this EventIdentifiers.  # noqa: E501
        :type: str
        """

        self._whatsapp_id = whatsapp_id

    @property
    def landline_number_id(self):
        """Gets the landline_number_id of this EventIdentifiers.  # noqa: E501

        landline_number associated with the event  # noqa: E501

        :return: The landline_number_id of this EventIdentifiers.  # noqa: E501
        :rtype: str
        """
        return self._landline_number_id

    @landline_number_id.setter
    def landline_number_id(self, landline_number_id):
        """Sets the landline_number_id of this EventIdentifiers.

        landline_number associated with the event  # noqa: E501

        :param landline_number_id: The landline_number_id of this EventIdentifiers.  # noqa: E501
        :type: str
        """

        self._landline_number_id = landline_number_id

    @property
    def ext_id(self):
        """Gets the ext_id of this EventIdentifiers.  # noqa: E501

        ext_id associated with the event  # noqa: E501

        :return: The ext_id of this EventIdentifiers.  # noqa: E501
        :rtype: str
        """
        return self._ext_id

    @ext_id.setter
    def ext_id(self, ext_id):
        """Sets the ext_id of this EventIdentifiers.

        ext_id associated with the event  # noqa: E501

        :param ext_id: The ext_id of this EventIdentifiers.  # noqa: E501
        :type: str
        """

        self._ext_id = ext_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EventIdentifiers, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EventIdentifiers):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
