# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class FileData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'author_id': 'str',
        'contact_id': 'int',
        'deal_id': 'str',
        'company_id': 'str',
        'size': 'int',
        'created_at': 'datetime'
    }

    attribute_map = {
        'name': 'name',
        'author_id': 'authorId',
        'contact_id': 'contactId',
        'deal_id': 'dealId',
        'company_id': 'companyId',
        'size': 'size',
        'created_at': 'createdAt'
    }

    def __init__(self, name=None, author_id=None, contact_id=None, deal_id=None, company_id=None, size=None, created_at=None):  # noqa: E501
        """FileData - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._author_id = None
        self._contact_id = None
        self._deal_id = None
        self._company_id = None
        self._size = None
        self._created_at = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if author_id is not None:
            self.author_id = author_id
        if contact_id is not None:
            self.contact_id = contact_id
        if deal_id is not None:
            self.deal_id = deal_id
        if company_id is not None:
            self.company_id = company_id
        if size is not None:
            self.size = size
        if created_at is not None:
            self.created_at = created_at

    @property
    def name(self):
        """Gets the name of this FileData.  # noqa: E501

        Name of uploaded file  # noqa: E501

        :return: The name of this FileData.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FileData.

        Name of uploaded file  # noqa: E501

        :param name: The name of this FileData.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def author_id(self):
        """Gets the author_id of this FileData.  # noqa: E501

        Account id of user which created the file  # noqa: E501

        :return: The author_id of this FileData.  # noqa: E501
        :rtype: str
        """
        return self._author_id

    @author_id.setter
    def author_id(self, author_id):
        """Sets the author_id of this FileData.

        Account id of user which created the file  # noqa: E501

        :param author_id: The author_id of this FileData.  # noqa: E501
        :type: str
        """

        self._author_id = author_id

    @property
    def contact_id(self):
        """Gets the contact_id of this FileData.  # noqa: E501

        Contact id of contact on which file is uploaded  # noqa: E501

        :return: The contact_id of this FileData.  # noqa: E501
        :rtype: int
        """
        return self._contact_id

    @contact_id.setter
    def contact_id(self, contact_id):
        """Sets the contact_id of this FileData.

        Contact id of contact on which file is uploaded  # noqa: E501

        :param contact_id: The contact_id of this FileData.  # noqa: E501
        :type: int
        """

        self._contact_id = contact_id

    @property
    def deal_id(self):
        """Gets the deal_id of this FileData.  # noqa: E501

        Deal id linked to a file  # noqa: E501

        :return: The deal_id of this FileData.  # noqa: E501
        :rtype: str
        """
        return self._deal_id

    @deal_id.setter
    def deal_id(self, deal_id):
        """Sets the deal_id of this FileData.

        Deal id linked to a file  # noqa: E501

        :param deal_id: The deal_id of this FileData.  # noqa: E501
        :type: str
        """

        self._deal_id = deal_id

    @property
    def company_id(self):
        """Gets the company_id of this FileData.  # noqa: E501

        Company id linked to a file  # noqa: E501

        :return: The company_id of this FileData.  # noqa: E501
        :rtype: str
        """
        return self._company_id

    @company_id.setter
    def company_id(self, company_id):
        """Sets the company_id of this FileData.

        Company id linked to a file  # noqa: E501

        :param company_id: The company_id of this FileData.  # noqa: E501
        :type: str
        """

        self._company_id = company_id

    @property
    def size(self):
        """Gets the size of this FileData.  # noqa: E501

        Size of file in bytes  # noqa: E501

        :return: The size of this FileData.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this FileData.

        Size of file in bytes  # noqa: E501

        :param size: The size of this FileData.  # noqa: E501
        :type: int
        """

        self._size = size

    @property
    def created_at(self):
        """Gets the created_at of this FileData.  # noqa: E501

        File created date/time  # noqa: E501

        :return: The created_at of this FileData.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this FileData.

        File created date/time  # noqa: E501

        :param created_at: The created_at of this FileData.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FileData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FileData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
