# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class GetCouponCollection(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'default_coupon': 'str',
        'created_at': 'datetime',
        'total_coupons': 'int',
        'remaining_coupons': 'int',
        'expiration_date': 'datetime',
        'remaining_days_alert': 'int',
        'remaining_coupons_alert': 'int'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'default_coupon': 'defaultCoupon',
        'created_at': 'createdAt',
        'total_coupons': 'totalCoupons',
        'remaining_coupons': 'remainingCoupons',
        'expiration_date': 'expirationDate',
        'remaining_days_alert': 'remainingDaysAlert',
        'remaining_coupons_alert': 'remainingCouponsAlert'
    }

    def __init__(self, id=None, name=None, default_coupon=None, created_at=None, total_coupons=None, remaining_coupons=None, expiration_date=None, remaining_days_alert=None, remaining_coupons_alert=None):  # noqa: E501
        """GetCouponCollection - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._name = None
        self._default_coupon = None
        self._created_at = None
        self._total_coupons = None
        self._remaining_coupons = None
        self._expiration_date = None
        self._remaining_days_alert = None
        self._remaining_coupons_alert = None
        self.discriminator = None

        self.id = id
        self.name = name
        self.default_coupon = default_coupon
        self.created_at = created_at
        self.total_coupons = total_coupons
        self.remaining_coupons = remaining_coupons
        if expiration_date is not None:
            self.expiration_date = expiration_date
        if remaining_days_alert is not None:
            self.remaining_days_alert = remaining_days_alert
        if remaining_coupons_alert is not None:
            self.remaining_coupons_alert = remaining_coupons_alert

    @property
    def id(self):
        """Gets the id of this GetCouponCollection.  # noqa: E501

        The id of the collection.  # noqa: E501

        :return: The id of this GetCouponCollection.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this GetCouponCollection.

        The id of the collection.  # noqa: E501

        :param id: The id of this GetCouponCollection.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this GetCouponCollection.  # noqa: E501

        The name of the collection.  # noqa: E501

        :return: The name of this GetCouponCollection.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this GetCouponCollection.

        The name of the collection.  # noqa: E501

        :param name: The name of this GetCouponCollection.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def default_coupon(self):
        """Gets the default_coupon of this GetCouponCollection.  # noqa: E501

        The default coupon of the collection.  # noqa: E501

        :return: The default_coupon of this GetCouponCollection.  # noqa: E501
        :rtype: str
        """
        return self._default_coupon

    @default_coupon.setter
    def default_coupon(self, default_coupon):
        """Sets the default_coupon of this GetCouponCollection.

        The default coupon of the collection.  # noqa: E501

        :param default_coupon: The default_coupon of this GetCouponCollection.  # noqa: E501
        :type: str
        """
        if default_coupon is None:
            raise ValueError("Invalid value for `default_coupon`, must not be `None`")  # noqa: E501

        self._default_coupon = default_coupon

    @property
    def created_at(self):
        """Gets the created_at of this GetCouponCollection.  # noqa: E501

        Datetime on which the collection was created.  # noqa: E501

        :return: The created_at of this GetCouponCollection.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this GetCouponCollection.

        Datetime on which the collection was created.  # noqa: E501

        :param created_at: The created_at of this GetCouponCollection.  # noqa: E501
        :type: datetime
        """
        if created_at is None:
            raise ValueError("Invalid value for `created_at`, must not be `None`")  # noqa: E501

        self._created_at = created_at

    @property
    def total_coupons(self):
        """Gets the total_coupons of this GetCouponCollection.  # noqa: E501

        Total number of coupons in the collection.  # noqa: E501

        :return: The total_coupons of this GetCouponCollection.  # noqa: E501
        :rtype: int
        """
        return self._total_coupons

    @total_coupons.setter
    def total_coupons(self, total_coupons):
        """Sets the total_coupons of this GetCouponCollection.

        Total number of coupons in the collection.  # noqa: E501

        :param total_coupons: The total_coupons of this GetCouponCollection.  # noqa: E501
        :type: int
        """
        if total_coupons is None:
            raise ValueError("Invalid value for `total_coupons`, must not be `None`")  # noqa: E501

        self._total_coupons = total_coupons

    @property
    def remaining_coupons(self):
        """Gets the remaining_coupons of this GetCouponCollection.  # noqa: E501

        Number of coupons that have not been sent yet.  # noqa: E501

        :return: The remaining_coupons of this GetCouponCollection.  # noqa: E501
        :rtype: int
        """
        return self._remaining_coupons

    @remaining_coupons.setter
    def remaining_coupons(self, remaining_coupons):
        """Sets the remaining_coupons of this GetCouponCollection.

        Number of coupons that have not been sent yet.  # noqa: E501

        :param remaining_coupons: The remaining_coupons of this GetCouponCollection.  # noqa: E501
        :type: int
        """
        if remaining_coupons is None:
            raise ValueError("Invalid value for `remaining_coupons`, must not be `None`")  # noqa: E501

        self._remaining_coupons = remaining_coupons

    @property
    def expiration_date(self):
        """Gets the expiration_date of this GetCouponCollection.  # noqa: E501

        Expiration date for the coupon collection in RFC3339 format.  # noqa: E501

        :return: The expiration_date of this GetCouponCollection.  # noqa: E501
        :rtype: datetime
        """
        return self._expiration_date

    @expiration_date.setter
    def expiration_date(self, expiration_date):
        """Sets the expiration_date of this GetCouponCollection.

        Expiration date for the coupon collection in RFC3339 format.  # noqa: E501

        :param expiration_date: The expiration_date of this GetCouponCollection.  # noqa: E501
        :type: datetime
        """

        self._expiration_date = expiration_date

    @property
    def remaining_days_alert(self):
        """Gets the remaining_days_alert of this GetCouponCollection.  # noqa: E501

        If present, an email notification is going to be sent the defined amount of days before the expiration date.  # noqa: E501

        :return: The remaining_days_alert of this GetCouponCollection.  # noqa: E501
        :rtype: int
        """
        return self._remaining_days_alert

    @remaining_days_alert.setter
    def remaining_days_alert(self, remaining_days_alert):
        """Sets the remaining_days_alert of this GetCouponCollection.

        If present, an email notification is going to be sent the defined amount of days before the expiration date.  # noqa: E501

        :param remaining_days_alert: The remaining_days_alert of this GetCouponCollection.  # noqa: E501
        :type: int
        """

        self._remaining_days_alert = remaining_days_alert

    @property
    def remaining_coupons_alert(self):
        """Gets the remaining_coupons_alert of this GetCouponCollection.  # noqa: E501

        If present, an email notification is going to be sent when the total number of available coupons falls below the defined threshold.  # noqa: E501

        :return: The remaining_coupons_alert of this GetCouponCollection.  # noqa: E501
        :rtype: int
        """
        return self._remaining_coupons_alert

    @remaining_coupons_alert.setter
    def remaining_coupons_alert(self, remaining_coupons_alert):
        """Sets the remaining_coupons_alert of this GetCouponCollection.

        If present, an email notification is going to be sent when the total number of available coupons falls below the defined threshold.  # noqa: E501

        :param remaining_coupons_alert: The remaining_coupons_alert of this GetCouponCollection.  # noqa: E501
        :type: int
        """

        self._remaining_coupons_alert = remaining_coupons_alert

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetCouponCollection, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetCouponCollection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
