# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class GetDomainConfigurationModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'domain': 'str',
        'verified': 'bool',
        'authenticated': 'bool',
        'dns_records': 'CreateDomainModelDnsRecords'
    }

    attribute_map = {
        'domain': 'domain',
        'verified': 'verified',
        'authenticated': 'authenticated',
        'dns_records': 'dns_records'
    }

    def __init__(self, domain=None, verified=None, authenticated=None, dns_records=None):  # noqa: E501
        """GetDomainConfigurationModel - a model defined in Swagger"""  # noqa: E501

        self._domain = None
        self._verified = None
        self._authenticated = None
        self._dns_records = None
        self.discriminator = None

        self.domain = domain
        self.verified = verified
        self.authenticated = authenticated
        self.dns_records = dns_records

    @property
    def domain(self):
        """Gets the domain of this GetDomainConfigurationModel.  # noqa: E501

        Domain  # noqa: E501

        :return: The domain of this GetDomainConfigurationModel.  # noqa: E501
        :rtype: str
        """
        return self._domain

    @domain.setter
    def domain(self, domain):
        """Sets the domain of this GetDomainConfigurationModel.

        Domain  # noqa: E501

        :param domain: The domain of this GetDomainConfigurationModel.  # noqa: E501
        :type: str
        """
        if domain is None:
            raise ValueError("Invalid value for `domain`, must not be `None`")  # noqa: E501

        self._domain = domain

    @property
    def verified(self):
        """Gets the verified of this GetDomainConfigurationModel.  # noqa: E501

        Status of domain verification (true=verified, false=non verified)  # noqa: E501

        :return: The verified of this GetDomainConfigurationModel.  # noqa: E501
        :rtype: bool
        """
        return self._verified

    @verified.setter
    def verified(self, verified):
        """Sets the verified of this GetDomainConfigurationModel.

        Status of domain verification (true=verified, false=non verified)  # noqa: E501

        :param verified: The verified of this GetDomainConfigurationModel.  # noqa: E501
        :type: bool
        """
        if verified is None:
            raise ValueError("Invalid value for `verified`, must not be `None`")  # noqa: E501

        self._verified = verified

    @property
    def authenticated(self):
        """Gets the authenticated of this GetDomainConfigurationModel.  # noqa: E501

        Status of domain authentication (true=authenticated, false=non authenticated)  # noqa: E501

        :return: The authenticated of this GetDomainConfigurationModel.  # noqa: E501
        :rtype: bool
        """
        return self._authenticated

    @authenticated.setter
    def authenticated(self, authenticated):
        """Sets the authenticated of this GetDomainConfigurationModel.

        Status of domain authentication (true=authenticated, false=non authenticated)  # noqa: E501

        :param authenticated: The authenticated of this GetDomainConfigurationModel.  # noqa: E501
        :type: bool
        """
        if authenticated is None:
            raise ValueError("Invalid value for `authenticated`, must not be `None`")  # noqa: E501

        self._authenticated = authenticated

    @property
    def dns_records(self):
        """Gets the dns_records of this GetDomainConfigurationModel.  # noqa: E501


        :return: The dns_records of this GetDomainConfigurationModel.  # noqa: E501
        :rtype: CreateDomainModelDnsRecords
        """
        return self._dns_records

    @dns_records.setter
    def dns_records(self, dns_records):
        """Sets the dns_records of this GetDomainConfigurationModel.


        :param dns_records: The dns_records of this GetDomainConfigurationModel.  # noqa: E501
        :type: CreateDomainModelDnsRecords
        """
        if dns_records is None:
            raise ValueError("Invalid value for `dns_records`, must not be `None`")  # noqa: E501

        self._dns_records = dns_records

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetDomainConfigurationModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetDomainConfigurationModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
