# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class GetDomainsListDomains(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'domain_name': 'str',
        'authenticated': 'bool',
        'verified': 'bool',
        'ip': 'str'
    }

    attribute_map = {
        'id': 'id',
        'domain_name': 'domain_name',
        'authenticated': 'authenticated',
        'verified': 'verified',
        'ip': 'ip'
    }

    def __init__(self, id=None, domain_name=None, authenticated=None, verified=None, ip=None):  # noqa: E501
        """GetDomainsListDomains - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._domain_name = None
        self._authenticated = None
        self._verified = None
        self._ip = None
        self.discriminator = None

        self.id = id
        self.domain_name = domain_name
        self.authenticated = authenticated
        self.verified = verified
        if ip is not None:
            self.ip = ip

    @property
    def id(self):
        """Gets the id of this GetDomainsListDomains.  # noqa: E501

        Id of the domain  # noqa: E501

        :return: The id of this GetDomainsListDomains.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this GetDomainsListDomains.

        Id of the domain  # noqa: E501

        :param id: The id of this GetDomainsListDomains.  # noqa: E501
        :type: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def domain_name(self):
        """Gets the domain_name of this GetDomainsListDomains.  # noqa: E501

        Domain name  # noqa: E501

        :return: The domain_name of this GetDomainsListDomains.  # noqa: E501
        :rtype: str
        """
        return self._domain_name

    @domain_name.setter
    def domain_name(self, domain_name):
        """Sets the domain_name of this GetDomainsListDomains.

        Domain name  # noqa: E501

        :param domain_name: The domain_name of this GetDomainsListDomains.  # noqa: E501
        :type: str
        """
        if domain_name is None:
            raise ValueError("Invalid value for `domain_name`, must not be `None`")  # noqa: E501

        self._domain_name = domain_name

    @property
    def authenticated(self):
        """Gets the authenticated of this GetDomainsListDomains.  # noqa: E501

        Status of domain authentication (true=authenticated, false=non authenticated)  # noqa: E501

        :return: The authenticated of this GetDomainsListDomains.  # noqa: E501
        :rtype: bool
        """
        return self._authenticated

    @authenticated.setter
    def authenticated(self, authenticated):
        """Sets the authenticated of this GetDomainsListDomains.

        Status of domain authentication (true=authenticated, false=non authenticated)  # noqa: E501

        :param authenticated: The authenticated of this GetDomainsListDomains.  # noqa: E501
        :type: bool
        """
        if authenticated is None:
            raise ValueError("Invalid value for `authenticated`, must not be `None`")  # noqa: E501

        self._authenticated = authenticated

    @property
    def verified(self):
        """Gets the verified of this GetDomainsListDomains.  # noqa: E501

        Status of domain verification (true=verified, false=non verified)  # noqa: E501

        :return: The verified of this GetDomainsListDomains.  # noqa: E501
        :rtype: bool
        """
        return self._verified

    @verified.setter
    def verified(self, verified):
        """Sets the verified of this GetDomainsListDomains.

        Status of domain verification (true=verified, false=non verified)  # noqa: E501

        :param verified: The verified of this GetDomainsListDomains.  # noqa: E501
        :type: bool
        """
        if verified is None:
            raise ValueError("Invalid value for `verified`, must not be `None`")  # noqa: E501

        self._verified = verified

    @property
    def ip(self):
        """Gets the ip of this GetDomainsListDomains.  # noqa: E501

        Dedicated IP associated with domain  # noqa: E501

        :return: The ip of this GetDomainsListDomains.  # noqa: E501
        :rtype: str
        """
        return self._ip

    @ip.setter
    def ip(self, ip):
        """Sets the ip of this GetDomainsListDomains.

        Dedicated IP associated with domain  # noqa: E501

        :param ip: The ip of this GetDomainsListDomains.  # noqa: E501
        :type: str
        """

        self._ip = ip

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetDomainsListDomains, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetDomainsListDomains):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
