# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class MasterDetailsResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'email': 'str',
        'company_name': 'str',
        'id': 'int',
        'currency_code': 'str',
        'timezone': 'str',
        'billing_info': 'MasterDetailsResponseBillingInfo',
        'plan_info': 'MasterDetailsResponsePlanInfo'
    }

    attribute_map = {
        'email': 'email',
        'company_name': 'companyName',
        'id': 'id',
        'currency_code': 'currencyCode',
        'timezone': 'timezone',
        'billing_info': 'billingInfo',
        'plan_info': 'planInfo'
    }

    def __init__(self, email=None, company_name=None, id=None, currency_code=None, timezone=None, billing_info=None, plan_info=None):  # noqa: E501
        """MasterDetailsResponse - a model defined in Swagger"""  # noqa: E501

        self._email = None
        self._company_name = None
        self._id = None
        self._currency_code = None
        self._timezone = None
        self._billing_info = None
        self._plan_info = None
        self.discriminator = None

        if email is not None:
            self.email = email
        if company_name is not None:
            self.company_name = company_name
        if id is not None:
            self.id = id
        if currency_code is not None:
            self.currency_code = currency_code
        if timezone is not None:
            self.timezone = timezone
        if billing_info is not None:
            self.billing_info = billing_info
        if plan_info is not None:
            self.plan_info = plan_info

    @property
    def email(self):
        """Gets the email of this MasterDetailsResponse.  # noqa: E501

        Email id of master account  # noqa: E501

        :return: The email of this MasterDetailsResponse.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this MasterDetailsResponse.

        Email id of master account  # noqa: E501

        :param email: The email of this MasterDetailsResponse.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def company_name(self):
        """Gets the company_name of this MasterDetailsResponse.  # noqa: E501

        Company name of master account organization  # noqa: E501

        :return: The company_name of this MasterDetailsResponse.  # noqa: E501
        :rtype: str
        """
        return self._company_name

    @company_name.setter
    def company_name(self, company_name):
        """Sets the company_name of this MasterDetailsResponse.

        Company name of master account organization  # noqa: E501

        :param company_name: The company_name of this MasterDetailsResponse.  # noqa: E501
        :type: str
        """

        self._company_name = company_name

    @property
    def id(self):
        """Gets the id of this MasterDetailsResponse.  # noqa: E501

        Unique identifier of the master account organization  # noqa: E501

        :return: The id of this MasterDetailsResponse.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MasterDetailsResponse.

        Unique identifier of the master account organization  # noqa: E501

        :param id: The id of this MasterDetailsResponse.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def currency_code(self):
        """Gets the currency_code of this MasterDetailsResponse.  # noqa: E501

        Currency code of the master account organization  # noqa: E501

        :return: The currency_code of this MasterDetailsResponse.  # noqa: E501
        :rtype: str
        """
        return self._currency_code

    @currency_code.setter
    def currency_code(self, currency_code):
        """Sets the currency_code of this MasterDetailsResponse.

        Currency code of the master account organization  # noqa: E501

        :param currency_code: The currency_code of this MasterDetailsResponse.  # noqa: E501
        :type: str
        """

        self._currency_code = currency_code

    @property
    def timezone(self):
        """Gets the timezone of this MasterDetailsResponse.  # noqa: E501

        Timezone of the master account organization  # noqa: E501

        :return: The timezone of this MasterDetailsResponse.  # noqa: E501
        :rtype: str
        """
        return self._timezone

    @timezone.setter
    def timezone(self, timezone):
        """Sets the timezone of this MasterDetailsResponse.

        Timezone of the master account organization  # noqa: E501

        :param timezone: The timezone of this MasterDetailsResponse.  # noqa: E501
        :type: str
        """

        self._timezone = timezone

    @property
    def billing_info(self):
        """Gets the billing_info of this MasterDetailsResponse.  # noqa: E501


        :return: The billing_info of this MasterDetailsResponse.  # noqa: E501
        :rtype: MasterDetailsResponseBillingInfo
        """
        return self._billing_info

    @billing_info.setter
    def billing_info(self, billing_info):
        """Sets the billing_info of this MasterDetailsResponse.


        :param billing_info: The billing_info of this MasterDetailsResponse.  # noqa: E501
        :type: MasterDetailsResponseBillingInfo
        """

        self._billing_info = billing_info

    @property
    def plan_info(self):
        """Gets the plan_info of this MasterDetailsResponse.  # noqa: E501


        :return: The plan_info of this MasterDetailsResponse.  # noqa: E501
        :rtype: MasterDetailsResponsePlanInfo
        """
        return self._plan_info

    @plan_info.setter
    def plan_info(self, plan_info):
        """Sets the plan_info of this MasterDetailsResponse.


        :param plan_info: The plan_info of this MasterDetailsResponse.  # noqa: E501
        :type: MasterDetailsResponsePlanInfo
        """

        self._plan_info = plan_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MasterDetailsResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MasterDetailsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
