# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class MasterDetailsResponseBillingInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'email': 'str',
        'company_name': 'str',
        'name': 'MasterDetailsResponseBillingInfoName',
        'address': 'MasterDetailsResponseBillingInfoAddress'
    }

    attribute_map = {
        'email': 'email',
        'company_name': 'companyName',
        'name': 'name',
        'address': 'address'
    }

    def __init__(self, email=None, company_name=None, name=None, address=None):  # noqa: E501
        """MasterDetailsResponseBillingInfo - a model defined in Swagger"""  # noqa: E501

        self._email = None
        self._company_name = None
        self._name = None
        self._address = None
        self.discriminator = None

        if email is not None:
            self.email = email
        if company_name is not None:
            self.company_name = company_name
        if name is not None:
            self.name = name
        if address is not None:
            self.address = address

    @property
    def email(self):
        """Gets the email of this MasterDetailsResponseBillingInfo.  # noqa: E501

        Billing email id of master account  # noqa: E501

        :return: The email of this MasterDetailsResponseBillingInfo.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this MasterDetailsResponseBillingInfo.

        Billing email id of master account  # noqa: E501

        :param email: The email of this MasterDetailsResponseBillingInfo.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def company_name(self):
        """Gets the company_name of this MasterDetailsResponseBillingInfo.  # noqa: E501

        Company name of master account  # noqa: E501

        :return: The company_name of this MasterDetailsResponseBillingInfo.  # noqa: E501
        :rtype: str
        """
        return self._company_name

    @company_name.setter
    def company_name(self, company_name):
        """Sets the company_name of this MasterDetailsResponseBillingInfo.

        Company name of master account  # noqa: E501

        :param company_name: The company_name of this MasterDetailsResponseBillingInfo.  # noqa: E501
        :type: str
        """

        self._company_name = company_name

    @property
    def name(self):
        """Gets the name of this MasterDetailsResponseBillingInfo.  # noqa: E501


        :return: The name of this MasterDetailsResponseBillingInfo.  # noqa: E501
        :rtype: MasterDetailsResponseBillingInfoName
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this MasterDetailsResponseBillingInfo.


        :param name: The name of this MasterDetailsResponseBillingInfo.  # noqa: E501
        :type: MasterDetailsResponseBillingInfoName
        """

        self._name = name

    @property
    def address(self):
        """Gets the address of this MasterDetailsResponseBillingInfo.  # noqa: E501


        :return: The address of this MasterDetailsResponseBillingInfo.  # noqa: E501
        :rtype: MasterDetailsResponseBillingInfoAddress
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this MasterDetailsResponseBillingInfo.


        :param address: The address of this MasterDetailsResponseBillingInfo.  # noqa: E501
        :type: MasterDetailsResponseBillingInfoAddress
        """

        self._address = address

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MasterDetailsResponseBillingInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MasterDetailsResponseBillingInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
