# coding: utf-8

"""
    Brevo API

    Brevo provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/brevo  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  |   | 422  | Error. Unprocessable Entity |   # noqa: E501

    OpenAPI spec version: 3.0.0
    Contact: contact@brevo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class WhatsappCampStats(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sent': 'int',
        'delivered': 'int',
        'read': 'int',
        'unsubscribe': 'int',
        'not_sent': 'int'
    }

    attribute_map = {
        'sent': 'sent',
        'delivered': 'delivered',
        'read': 'read',
        'unsubscribe': 'unsubscribe',
        'not_sent': 'not_sent'
    }

    def __init__(self, sent=None, delivered=None, read=None, unsubscribe=None, not_sent=None):  # noqa: E501
        """WhatsappCampStats - a model defined in Swagger"""  # noqa: E501

        self._sent = None
        self._delivered = None
        self._read = None
        self._unsubscribe = None
        self._not_sent = None
        self.discriminator = None

        self.sent = sent
        self.delivered = delivered
        self.read = read
        self.unsubscribe = unsubscribe
        self.not_sent = not_sent

    @property
    def sent(self):
        """Gets the sent of this WhatsappCampStats.  # noqa: E501


        :return: The sent of this WhatsappCampStats.  # noqa: E501
        :rtype: int
        """
        return self._sent

    @sent.setter
    def sent(self, sent):
        """Sets the sent of this WhatsappCampStats.


        :param sent: The sent of this WhatsappCampStats.  # noqa: E501
        :type: int
        """
        if sent is None:
            raise ValueError("Invalid value for `sent`, must not be `None`")  # noqa: E501

        self._sent = sent

    @property
    def delivered(self):
        """Gets the delivered of this WhatsappCampStats.  # noqa: E501


        :return: The delivered of this WhatsappCampStats.  # noqa: E501
        :rtype: int
        """
        return self._delivered

    @delivered.setter
    def delivered(self, delivered):
        """Sets the delivered of this WhatsappCampStats.


        :param delivered: The delivered of this WhatsappCampStats.  # noqa: E501
        :type: int
        """
        if delivered is None:
            raise ValueError("Invalid value for `delivered`, must not be `None`")  # noqa: E501

        self._delivered = delivered

    @property
    def read(self):
        """Gets the read of this WhatsappCampStats.  # noqa: E501


        :return: The read of this WhatsappCampStats.  # noqa: E501
        :rtype: int
        """
        return self._read

    @read.setter
    def read(self, read):
        """Sets the read of this WhatsappCampStats.


        :param read: The read of this WhatsappCampStats.  # noqa: E501
        :type: int
        """
        if read is None:
            raise ValueError("Invalid value for `read`, must not be `None`")  # noqa: E501

        self._read = read

    @property
    def unsubscribe(self):
        """Gets the unsubscribe of this WhatsappCampStats.  # noqa: E501


        :return: The unsubscribe of this WhatsappCampStats.  # noqa: E501
        :rtype: int
        """
        return self._unsubscribe

    @unsubscribe.setter
    def unsubscribe(self, unsubscribe):
        """Sets the unsubscribe of this WhatsappCampStats.


        :param unsubscribe: The unsubscribe of this WhatsappCampStats.  # noqa: E501
        :type: int
        """
        if unsubscribe is None:
            raise ValueError("Invalid value for `unsubscribe`, must not be `None`")  # noqa: E501

        self._unsubscribe = unsubscribe

    @property
    def not_sent(self):
        """Gets the not_sent of this WhatsappCampStats.  # noqa: E501


        :return: The not_sent of this WhatsappCampStats.  # noqa: E501
        :rtype: int
        """
        return self._not_sent

    @not_sent.setter
    def not_sent(self, not_sent):
        """Sets the not_sent of this WhatsappCampStats.


        :param not_sent: The not_sent of this WhatsappCampStats.  # noqa: E501
        :type: int
        """
        if not_sent is None:
            raise ValueError("Invalid value for `not_sent`, must not be `None`")  # noqa: E501

        self._not_sent = not_sent

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WhatsappCampStats, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WhatsappCampStats):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
